'use strict';

Object.defineProperty(exports, '__esModule', {
  value: true
});

var React = require('react');

var classnames = require('classnames');

var compose = require('lodash/fp/compose');

var curryN = require('lodash/fp/curryN');

var utilsCommons = require('@highlight-ui/utils-commons');

var icon = require('@highlight-ui/icon');

var typographyColorTokens = require('@highlight-ui/tokens/dist/typographyColors.json');

function _interopDefaultLegacy(e) {
  return e && typeof e === 'object' && 'default' in e ? e : {
    'default': e
  };
}

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);

var classnames__default = /*#__PURE__*/_interopDefaultLegacy(classnames);

var compose__default = /*#__PURE__*/_interopDefaultLegacy(compose);

var curryN__default = /*#__PURE__*/_interopDefaultLegacy(curryN);

var typographyColorTokens__default = /*#__PURE__*/_interopDefaultLegacy(typographyColorTokens);
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */


var __assign$1 = function () {
  __assign$1 = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign$1.apply(this, arguments);
};

function __spreadArray(to, from, pack) {
  if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
    if (ar || !(i in from)) {
      if (!ar) ar = Array.prototype.slice.call(from, 0, i);
      ar[i] = from[i];
    }
  }
  return to.concat(ar || Array.prototype.slice.call(from));
}

var styles$1 = {
  "pagination": "Pagination-module__2H3nOfON__v3-0-11",
  "page": "Pagination-module__29JdyONz__v3-0-11",
  "pageButton": "Pagination-module__352g20q4__v3-0-11",
  "active": "Pagination-module__2pIiLAwQ__v3-0-11"
};

function calcMaxPage(limit, total) {
  return Math.ceil(total / limit);
}

function calcPage(limit, offset) {
  return Math.ceil((offset + limit) / limit);
}

function calcCenterPagePosition(maxItems) {
  return Math.ceil(maxItems / 2);
}

function getPrevNumberList(acc, num, limit) {
  return num <= 1 || limit < 1 ? acc : getPrevNumberList(__spreadArray([num - 1], acc, true), num - 1, limit - 1);
}

function incrementList(acc, maxLength, limit, page) {
  return acc.length >= maxLength || page > limit ? acc : incrementList(__spreadArray(__spreadArray([], acc, true), [page], false), maxLength, limit, page + 1);
}

function calcOffset(limit, page) {
  return page * limit - limit;
}

function getPageFromEvent(e) {
  var _a;

  return (_a = e.currentTarget.dataset.page) !== null && _a !== void 0 ? _a : '';
}

var Nav = function (_a) {
  var buttonClassName = _a.buttonClassName,
      className = _a.className,
      page = _a.page,
      icon$1 = _a.icon,
      onClick = _a.onClick;
  return React__default["default"].createElement("li", __assign$1({
    className: className
  }, utilsCommons.parseMetadata({
    testId: 'pagination-nav'
  })), React__default["default"].createElement("a", {
    role: "button",
    "data-page": page,
    onClick: onClick,
    className: buttonClassName
  }, React__default["default"].createElement(icon.Icon, {
    name: icon$1,
    color: "icon-default"
  })));
};
/*! *****************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */


var __assign = function () {
  __assign = Object.assign || function __assign(t) {
    for (var s, i = 1, n = arguments.length; i < n; i++) {
      s = arguments[i];

      for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p)) t[p] = s[p];
    }

    return t;
  };

  return __assign.apply(this, arguments);
};

function __rest(s, e) {
  var t = {};

  for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];

  if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
    if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i])) t[p[i]] = s[p[i]];
  }
  return t;
}

var styles = {
  "typography": "Typography-module__1pVtEBEF__v4-0-8",
  "heading-1": "Typography-module__3Z0Oot5O__v4-0-8",
  "heading-2": "Typography-module__1JbxWZF3__v4-0-8",
  "heading-3": "Typography-module__2xWY5JDF__v4-0-8",
  "heading-4": "Typography-module__2LqCsgLQ__v4-0-8",
  "subtitle-1": "Typography-module__13OtDNn___v4-0-8",
  "subtitle-2": "Typography-module__1vaNFaoa__v4-0-8",
  "subtitle-3": "Typography-module__OU90cvvz__v4-0-8",
  "subtitle-4": "Typography-module__1gRqi1a1__v4-0-8",
  "body-1": "Typography-module__2uoDh7Lc__v4-0-8",
  "button-1": "Typography-module__1KnOaXLm__v4-0-8",
  "caption-1": "Typography-module__2gU8wbJ6__v4-0-8",
  "caption-2": "Typography-module__3lmxW6P0__v4-0-8",
  "overline-1": "Typography-module__2-d12Wsw__v4-0-8"
};
var variantMapping = {
  'heading-1': 'h1',
  'heading-2': 'h2',
  'heading-3': 'h3',
  'heading-4': 'h4',
  'subtitle-1': 'h6',
  'subtitle-2': 'h6',
  'subtitle-3': 'h6',
  'subtitle-4': 'h6',
  'body-1': 'p',
  'button-1': 'span',
  'caption-1': 'span',
  'caption-2': 'span',
  'overline-1': 'span'
};

var TypographyWithRef = function (_a, ref) {
  var children = _a.children,
      className = _a.className,
      component = _a.component,
      variant = _a.variant,
      color = _a.color,
      style = _a.style,
      otherProps = __rest(_a, ["children", "className", "component", "variant", "color", "style"]);

  var tag = component || variantMapping[variant];
  return React__default["default"].createElement(tag, __assign(__assign({}, otherProps), {
    ref: ref,
    style: __assign({
      color: color && typographyColorTokens__default["default"][color]
    }, style),
    className: classnames__default["default"](styles[variant], className, styles.typography)
  }), children);
};

TypographyWithRef.displayName = 'Typography';
var Typography = React__default["default"].forwardRef(TypographyWithRef);
var Pagination = React__default["default"].forwardRef(function (_a, ref) {
  var className = _a.className,
      metadata = _a.metadata,
      _b = _a.firstPageIconName,
      first = _b === void 0 ? 'angle-double-left' : _b,
      _c = _a.prevPageIconName,
      prev = _c === void 0 ? 'angle-left' : _c,
      _d = _a.nextPageIconName,
      next = _d === void 0 ? 'angle-right' : _d,
      _e = _a.lastPageIconName,
      last = _e === void 0 ? 'angle-double-right' : _e,
      limit = _a.limit,
      _f = _a.maxItems,
      maxItems = _f === void 0 ? 0 : _f,
      offset = _a.offset,
      onChange = _a.onChange,
      total = _a.total;
  var maxPage = calcMaxPage(limit, total);
  var page = calcPage(limit, offset);
  var centerIndex = calcCenterPagePosition(maxItems);
  var previousPages = getPrevNumberList([], page, centerIndex - 1);
  var displayList = incrementList(previousPages, maxItems, maxPage, page);
  var getOffsetOf = curryN__default["default"](2, calcOffset)(limit);
  var onPaginate = compose__default["default"]([onChange, getOffsetOf, Number, getPageFromEvent]);
  return React__default["default"].createElement("ul", __assign$1({
    className: classnames__default["default"](styles$1.pagination, className),
    ref: ref
  }, utilsCommons.parseMetadata(metadata)), page > 1 && React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement(Nav, {
    page: 1,
    icon: first,
    onClick: onPaginate,
    className: styles$1.page,
    buttonClassName: styles$1.pageButton
  }), React__default["default"].createElement(Nav, {
    page: page - 1,
    icon: prev,
    onClick: onPaginate,
    buttonClassName: styles$1.pageButton
  })), displayList.map(function (innerPage) {
    var _a;

    return React__default["default"].createElement("li", {
      key: innerPage,
      className: styles$1.page
    }, React__default["default"].createElement("a", __assign$1({}, utilsCommons.parseMetadata({
      testId: "pagination-page-" + innerPage
    }), {
      role: "button",
      "data-page": innerPage,
      className: classnames__default["default"](styles$1.pageButton, (_a = {}, _a[styles$1.active] = innerPage === page, _a)),
      onClick: onPaginate
    }), React__default["default"].createElement(Typography, {
      variant: "button-1",
      component: "span"
    }, innerPage)));
  }), page < maxPage && React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement(Nav, {
    page: page + 1,
    icon: next,
    onClick: onPaginate,
    buttonClassName: styles$1.pageButton
  }), React__default["default"].createElement(Nav, {
    page: maxPage,
    icon: last,
    onClick: onPaginate,
    buttonClassName: styles$1.pageButton
  })));
});
exports.Pagination = Pagination;
//# sourceMappingURL=index.js.map
