import React from 'react';
import { PropsWithMetadata } from '@highlight-ui/utils-commons';
export declare type PaginationProps = PropsWithMetadata<{
    /** Icon for "go to the first page" button */
    firstPageIconName?: string;
    /** Icon for "go to the last page" button */
    lastPageIconName?: string;
    /** How many items are shown on the page */
    limit: number;
    /** How many page buttons are shown */
    maxItems?: number;
    /** Icon for "go to the next page" button */
    nextPageIconName?: string;
    /** Used to calculate current page */
    offset: number;
    /** Callback that is invoked when the page is selected or navigation buttons are clicked.
     *  The `offset` parameter is the index in the items array in which the clicked page starts from */
    onChange: (offset: number) => void;
    /** Icon for "go to the previous page" button */
    prevPageIconName?: string;
    /** Total number of items */
    total: number;
    /** Allows providing a custom class name */
    className?: string;
}>;
declare const Pagination: React.ForwardRefExoticComponent<{
    /** Icon for "go to the first page" button */
    firstPageIconName?: string | undefined;
    /** Icon for "go to the last page" button */
    lastPageIconName?: string | undefined;
    /** How many items are shown on the page */
    limit: number;
    /** How many page buttons are shown */
    maxItems?: number | undefined;
    /** Icon for "go to the next page" button */
    nextPageIconName?: string | undefined;
    /** Used to calculate current page */
    offset: number;
    /** Callback that is invoked when the page is selected or navigation buttons are clicked.
     *  The `offset` parameter is the index in the items array in which the clicked page starts from */
    onChange: (offset: number) => void;
    /** Icon for "go to the previous page" button */
    prevPageIconName?: string | undefined;
    /** Total number of items */
    total: number;
    /** Allows providing a custom class name */
    className?: string | undefined;
} & {
    metadata?: import("@highlight-ui/utils-commons").ComponentMetadata | undefined;
} & React.RefAttributes<HTMLUListElement>>;
export default Pagination;
